<template>
  <v-app class="authPage">

    <AccountantNavigation v-if="role === 'ROLE_ACCOUNTANT'"></AccountantNavigation>
    <MedicalStaffNavigation v-if="role === 'ROLE_DOCTOR'"></MedicalStaffNavigation>


    <div v-if="notAuth">
      <v-container class="authPage__item">
        <h1>Авторизация</h1>
        <v-row class="text-center authPage__item__inputs">
          <v-col cols="12">
            <v-col cols="12" sm="6" md="12" style="align-items: center">
              <v-text-field v-model="login" label="Логин" :rules="required" required></v-text-field>
            </v-col>
            <v-col cols="12" sm="6" md="12">
              <v-text-field type="password" v-model="password" label="Пароль" :rules="required" required></v-text-field>
            </v-col>
            <v-container>
              <v-btn color="#858585" @click="loginMethod">
                Войти
              </v-btn>
            </v-container>
          </v-col>
        </v-row>
      </v-container>
    </div>

    <AccountantFooter v-if="role === 'ROLE_ACCOUNTANT'"></AccountantFooter>
    <MedicalStaffFooter v-if="role === 'ROLE_DOCTOR'"></MedicalStaffFooter>
  </v-app>
</template>

<script>

import AccountantNavigation from "./pages/accountant/AccountantNavigation";
import MedicalStaffNavigation from "./pages/medicalStaff/MedicalStaffNavigation";
import VueJwtDecode from 'vue-jwt-decode'
import axios from "axios";
import MedicalStaffFooter from "./pages/medicalStaff/MedicalStaffFooter";
import AccountantFooter from "./pages/accountant/AccountantFooter";

export default {
  name: 'App',
  components: {
    AccountantFooter,
    MedicalStaffFooter,
    MedicalStaffNavigation,
    AccountantNavigation
  },
  data() {
    return {
      login: '',
      password: '',
      role: '',
      notAuth: true,
      required: [
        v => !!v || 'Заполните это поле'
      ],
    }
  },

  header: {
    meta: {
      title: 'Медицинские услуги'
    }
  },

  methods: {
    async loginPost() {
      axios.post(this.$root.globalVar + '/authentication/authenticate', {
        email: this.login,
        password: this.password
      })
          .catch(error => {
            alert('Ошибка! Подробности: введите корректные логин / пароль.')
            console.log(error)
            window.location.reload()
          })
          .then(response => {
            axios.defaults.headers.common['Authorization'] = "Bearer " + response.data.jwtToken
            localStorage.setItem("user", "Bearer " + JSON.stringify(response.data.jwtToken))
            this.role = VueJwtDecode.decode(response.data.jwtToken).authorities
            console.log(this.role)

            if (this.role === 'ROLE_ACCOUNTANT') {
              this.$router.push('/drug')
            }
            else if (this.role === 'ROLE_DOCTOR') {
              this.$router.push('/medicalStaff_home')
            }
          })
    },

    loginMethod() {
      this.notAuth = false
      this.loginPost()
    }
  }
};
</script>

<style lang="scss" scoped>
.authPage {
  background: url('./assets/medical.png') no-repeat center center fixed !important;
  background-size: cover;

  &__item {

    &__inputs {
      margin-top: 300px;
    }

    h1 {
      text-align: center;
      margin-top: 60px;
    }
  }
}

.theme--light.v-application {
  color: #000000 !important;;
}
</style>
